function demoPatternBenny

%check for *j_pattern*v_pattern* where * is a sequence of any length

patternstate=1:10; % pattern states (1 per pattern)
j_state=1:5;
v_state=6:10;
generalstate=11:13; % general states

nstates=generalstate(end);
tran=zeros(nstates,nstates);

tran(generalstate(1),generalstate(1))=0.5; % not started j-seq
for p=j_state
    tran(patternstate(p),generalstate(1))=0.5/length(j_state); % into a j-seq
    tran(generalstate(2),patternstate(p))=1; % out of j-seq
end
tran(generalstate(2),generalstate(2))=0.5; % not start v-seq
for p=v_state
    tran(patternstate(p),generalstate(2))=0.5/length(v_state);
    tran(generalstate(3),patternstate(p))=1;
end
tran(generalstate(3),generalstate(3))=1;

% now expand states to deal with patterns
for p=j_state
    pattern{p}=randi(4,1,20);
end
for p=v_state
    pattern{p}=randi(4,1,20);
end

for pt=patternstate
    for l=1:length(pattern{pt})
        a=0.9;
        tmp=(1-a)/3*ones(4,1);
        tmp(pattern{pt}(l))=a;
        pvgh_pattern{pt,l}=tmp;
    end
end
for g=1:length(generalstate)
    pvgh_general(:,g)=ones(4,1)/4;
end

prior.generalstate=[1 0 0]'; % start in general pattern 1

[phghm,pvgh,ph1,startpatternIDX,endpatternIDX,generalstateIDX]=patternsearchsetup(pattern,patternstate,generalstate,tran,pvgh_pattern,pvgh_general,prior);

% generate some data from the model
T=100;
[v,h]=HMMsample(T,phghm,pvgh,ph1);
fprintf(1,'observed sequence: %s\n',v)

thresh=0*10e-6; % threshold for approximation. Set to zero for exact computation.
printtime=1;

[spphghm,pvgh,ph1,startpatternIDX,endpatternIDX,generalstateIDX]=patternsearchsetup(pattern,patternstate,generalstate,tran,pvgh_pattern,pvgh_general,prior);
[alpha,beta,gamma,delta,loglik,loglikpvhstar]=patternsearch(v,spphghm,pvgh,ph1,thresh,printtime);

[pnum gnum]=getpattern(delta,startpatternIDX,generalstateIDX); % just get which patterns these correspond to.

fprintf(1,'\nViterbi sequence corresponds to:\n\n')

fprintf(1,'observation: [patternstate generalstate]')
for i=1:length(v)
    fprintf(1,'\n          %s:         [%d        %d]',num2name(v(i)),pnum(i),gnum(i));
    if pnum(i)>0
        fprintf(1,' %d',pattern{pnum(i)})
    end
end
fprintf(1,'\n\nlikelihood log p(v_{1:T})=%f\n',loglik) % log probability of the sequence
fprintf(1,'likelihood log p(v_{1:T},h^*_{1:T})=%f\n',loglikpvhstar) % log probabilty of the joint seq and most likely explanation